// Functions for the explosive ball

// Prepares an explosive ball to explode
void PrepareExplosiveBallToExplode(int ID)
{
	SetPickUp(ID, 0);
	SetOnDamage(ID, "");
	SetObjectFloat(ID, 2, 1);
}

// Let an explosive ball explode and deltes it
void ExplosiveBallExplode(int ID)
{
	PrepareExplosiveBallToExplode(ID);

	// Effects
	AddEffect("Explosion2",     GetPosX(ID),GetPosY(ID),GetHeight(ID)+10);
	AddEffect("Nova",           GetPosX(ID),GetPosY(ID),GetHeight(ID)+10);
	AddEffect("Spheresplosion", GetPosX(ID),GetPosY(ID),GetHeight(ID)+10);
	RequestRunScript("AddEffect(\"Nova\","+string(GetPosX(ID))+","+string(GetPosY(ID))+","+string(GetHeight(ID)+10)+");",0.3);
	RequestRunScript("AddObject(\"burned_spot\","+string(GetPosX(ID))+","+string(GetPosY(ID))+",RAD(rand()*360));", 0.1);


	FadeOut(ID,0);

	// Explosion
	SetParty(ID, -1);
	switch (GetObjectFloat(ID, 2))
	{
		case 0:
			ExplosionDamageMagic(GetPosX(ID),GetPosY(ID), 50, 500,1, 92,64, ID, 0);
			break;
		case 1:
			ExplosionDamageMagic(GetPosX(ID),GetPosY(ID), 30, 500,1, 128,92, ID, 0);
			break;
		default:
			ExplosionDamageMagic(GetPosX(ID),GetPosY(ID), 50, 500,1, 92,64, ID, 0);
	}

	// Kill object
	RequestRunScript("SetLifeSpan("+string(ID)+",0);", 1);
}

// Waits iWaitTime sec and displays it above the ball => let it explode
void ExplosiveBallTimeExplode(int ID, int iWaitTime)
{
	PrepareExplosiveBallToExplode(ID);

	// Wich action?
	if (iWaitTime>=3)
	{
		RequestRunScript("AddEffect(\"Particle Flame small green\", 0,0,20,"+string(ID)+",0,0.5);", 1.0);
	}
	else if (iWaitTime==2)
	{
		RequestRunScript("AddEffect(\"Particle Flame small blue\", 0,0,20,"+string(ID)+",0,0.5);", 1.0);
//		AddEffect("Particle Flame small blue", 0,0,20, ID,0,0.5);
		//AddEffect("Reversesplosion", 0,0,20, ID,0,2);
		//RequestRunScript("AddEffect(\"Reversesplosion\", 0,0,20,"+string(ID)+",0,1.5);",0.5);
	}
	else if (iWaitTime==1)
	{
//		RequestRunScript("AddEffect(\"Particle Flame small red\", 0,0,20,"+string(ID)+",0,0.5);", 0.7);
	}
	else if (iWaitTime==0)
	{
		ExplosiveBallExplode(ID);
		return;
	}

	// Recall this function in 1 sec (iWaitTime-1)
	RequestRunScript("ExplosiveBallTimeExplode("+string(ID)+","+string(iWaitTime-1)+");", 1);
}

// Throws the ball and let it explote
void ExplosiveBallThrow(int ID)
{
	PrepareExplosiveBallToExplode(ID);

	SetMovePath(ID, 0,GetPosX(mc_ID),GetPosY(mc_ID), 1,GetPosX(mc_ID)+cos(GetAngle(mc_ID))*256,GetPosY(mc_ID)+sin(GetAngle(mc_ID))*256);
	SetMoveSpd(ID, 1);
	RequestRunScript("SetMoveSpd("+string(ID)+", 0);", 1);

	RequestRunScript("ExplosiveBallExplode("+string(ID)+");", 1);
}

// Returns 1 if the damges was given from an explosive ball(and valid) otherwise 0
int GotDamageFromExplosiveBall()
{
	if ( (obj[0]==-1)||(obj[1]==-1) )
		return 0;
	;

	if ( (Distance(obj[0],obj[1])>130)||(GetCfgID(obj[1])!="sc_it_explosive_01") )
	{
		return 0;
	}
	else
		return 1;
}
