void NPCObjBored(int idNPC, string sWrdID, int iCycle)
{
	if(IsValidObject(idNPC)&&!IsDead(idNPC))
	{
		NPCObj(idNPC, sWrdID);
		SetBoredCycle(idNPC, 0, iCycle); 
	}
}

void NPCPath(int idNPC, string sWrdID, int iCount)
{
	if (iCount<=0) exit;
	;
	SetAI(idNPC, "GOTO", sWrdID+"1");
	for (int i=2; i<=iCount; i++)
		AddAI(idNPC, "GOTO", sWrdID+string(i));

	int idObj=GetObject(sWrdID+string(iCount));
	float fAngle = GetAngle(idObj);
	SetLastTargetPos(idNPC, GetPosX(idObj)+cos(fAngle)*100, GetPosY(idObj)+sin(fAngle)*100);
	AddAI(idNPC, "AIM_AT", "LastTarget");
}

void NPCPathCall(int idNPC, string sWrdID, int iCount, string sFile)
{
	if (iCount<=0) exit;
	;
	SetAI(idNPC, "GOTO", sWrdID+"1");
	for (int i=2; i<=iCount; i++)
		AddAI(idNPC, "GOTO", sWrdID+string(i));

	int idObj=GetObject(sWrdID+string(iCount));
	float fAngle = GetAngle(idObj);
	SetLastTargetPos(idNPC, GetPosX(idObj)+cos(fAngle)*100, GetPosY(idObj)+sin(fAngle)*100);
	AddAI(idNPC, "AIM_AT", "LastTarget", "", 0, sFile);
}


void NPCPathWaitMC(int idNPC, string sWrdID, int iCount, string sFile)
{
	NPCPathWaitMC(idNPC, sWrdID, 1, iCount, sFile);
}

void NPCPathWaitMC(int idNPC, string sWrdID, int iPos, int iCount, string sFile)
{
	int idObj = GetObject(sWrdID+string(iPos));
	SetAITarget(idNPC, idObj);
	SetAI(idNPC, "CHANGE_STRATEGY", "LeadHero");
	SetEffBy(idObj, -1, GetWorldID(idNPC));
	if (iPos>1)
		SetOnCollision(GetObject(sWrdID+string(iPos-1)), "");
	if (iPos<iCount)
		SetOnCollision(idObj, "NPCPathWaitMC(obj[1],\""+sWrdID+"\", "+string(iPos+1)+", "+string(iCount)+",\""+sFile+"\");");
	else
	{
		int fAngle=GetAngle(idObj);
		SetLastTargetPos(idNPC, GetPosX(idObj)+cos(fAngle)*100, GetPosY(idObj)+sin(fAngle)*100);
		SetAI(idNPC, "AIM_AT", "LastTarget", "", 100, 1000, 0, sFile);
	}
}

void NPCFollowMC(int idNPC)
{
	SetAI(idNPC, "CHANGE_STRATEGY", "FollowMC");
}

void NPCWait(int idNPC)
{
	SetAI(idNPC, "WAIT", 0);
}

void NPCGoto(int idNPC, int idObj)
{
	SetAI(idNPC, "GOTO", idObj);
}

void NPCAttack(int idNPC, int idObj)
{
	SetAI(idNPC, "GOTO", idObj, "", 0);
}

void NPCGotoCall(int idNPC, int idObj, string sFinishAI)
{
	SetAI(idNPC, "GOTO", idObj, "", 100, 1000, 0, sFinishAI);
}

void NPCAddGotoCall(int idNPC, int idObj, string sFinishAI)
{
	AddAI(idNPC, "GOTO", idObj, 0, sFinishAI);
}

void NPCGotoStr(int idNPC, string sObj)
{
	SetAI(idNPC, "GOTO", sObj);
}

void NPCGotoStrCall(int idNPC, string sObj, string sFinishAI)
{
	SetAI(idNPC, "GOTO", sObj, "", 100, 1000, 0, sFinishAI);
}

void NPCAimAt(int idNPC, int idObj)
{
	SetAI(idNPC, "AIM_AT", idObj);
}

void NPCObj(int idNPC, string sObj)
{
	NPCObjID(idNPC, GetObject(sObj));
}

void NPCObjID(int idNPC, int idObj)
{
	SetPos(idNPC, GetPosX(idObj), GetPosY(idObj));
	SetAngle(idNPC, GetAngle(idObj));
}

void NPCVisible(int idNPC, int State)
{
	if (State==0)
	{
		SetUses(idNPC, 0);
		FadeOut(idNPC, 0);
		SetSolid(idNPC, 0);
		SetActive(idNPC, 0);
	}
	else
	{
		SetUses(idNPC, -1);
		FadeIn(idNPC, 0);
		SetSolid(idNPC, 1);
		SetActive(idNPC, 1);
	}
}

void NPCVisibleStr(string sNPC, int State)
{
	NPCVisible(GetObject(sNPC), State);
}

int NPCSpawn(string sCfgID, int ID)
{
	return AddObject(sCfgID, GetPosX(ID),GetPosY(ID), DEG(GetAngle(ID)));
}

int NPCSpawnStr(string sCfgID, string sID)
{
	int ID=GetObject(sID);
	return AddObject(sCfgID, GetPosX(ID),GetPosY(ID), DEG(GetAngle(ID)));
}

void NPCGotoObjRand(int idNPC, string sObj)
{
	int idObj=GetObject(sObj);
	fTmp[0]=rand()*RAD(180)*2;
	SetAIGotoPos(idNPC, GetPosX(idObj)+cos(fTmp[0])*GetSize(idObj), GetPosY(idObj)+sin(fTmp[0])*GetSize(idObj));
}

void NPCGotoObjRand(int idNPC, string sObj, int iPrior)
{
	int idObj=GetObject(sObj);
	fTmp[0]=rand()*RAD(180)*2;
	SetAIGotoPos(idNPC, GetPosX(idObj)+cos(fTmp[0])*GetSize(idObj), GetPosY(idObj)+sin(fTmp[0])*GetSize(idObj), iPrior);
}

void NPCGotoObjRandID(int idNPC, int idObj)
{
	fTmp[0]=rand()*RAD(180)*2;
	SetAIGotoPos(idNPC, GetPosX(idObj)+cos(fTmp[0])*GetSize(idObj), GetPosY(idObj)+sin(fTmp[0])*GetSize(idObj));
}

void NPCGotoObjRandID(int idNPC, int idObj, int iPrior)
{
	fTmp[0]=rand()*RAD(180)*2;
	SetAIGotoPos(idNPC, GetPosX(idObj)+cos(fTmp[0])*GetSize(idObj), GetPosY(idObj)+sin(fTmp[0])*GetSize(idObj), iPrior);
}

int NPCIsInObj(int idNPC, string sObj)
{
	int idObj = GetObject(sObj);
	if (Distance(idNPC, idObj)<GetSize(idObj))
		return 1;

	return 0;
}

int NPCFixPos(int idNPC, string sObj)
{
	int id=GetObject(sObj+"1");
	if (Distance(idNPC,id)>GetSize(idNPC)+GetSize(id))
	{
		NPCObj(idNPC, sObj+"2");
		return 1;
	}
	return 0;
}

int DropDemonicRemains(int idCreature)
{
	int id=AddObject("demonic_remains_01", GetPosX(idCreature), GetPosY(idCreature), GetAngle(idCreature));
	SetUseState(id, 1);
	if (GetNumberOfItemsInInventory(idCreature)>0)
	{
		TransferFromInventory(idCreature, id, "all");
	}
	return id;
}
