// On init the Watcher script is loaded
// other initialization may be done
 
// structure of init.c file is the following
// at first story constants are declared
// then level constants seperated in theme blocks meaning variables are grouped by semantic meaning
// then level variables are initialized and declared
// then Work is done which has to be done to initialize level


///////////////////////////////////////////////////////////////////////////////
//////////////////////////////story variable constants ////////////////////////
///////////////////////////////////////////////////////////////////////////////

//wizard trees
NewLevelVariable("wizardTreeString","string");
wizardTreeString =WizardTreeString;

NewLevelVariable("wizardTreeStoryGot","int");
wizardTreeStoryGot = WizardTreeStoryGot;

NewLevelVariable("fertilizerGot","int");
fertilizerGot = FertilizerGot;

NewLevelVariable("greenTreeFertilized","int");
greenTreeFertilized = 4;

NewLevelVariable("redTreeFertilized","int");
redTreeFertilized = 8;

NewLevelVariable("allKilledAndFertilized","int");
allKilledAndFertilized = AllKilledAndFertilized;

///////////////////////////////////////////////////////////////////////////////

//shooting competition

NewLevelVariable("shootingCompetitionString","string");
shootingCompetitionString ="ShootingCompetition";

NewLevelVariable("competitionEnd","int");
competitionEnd = 1;

NewLevelVariable("lastCompetitionWon","int");
lastCompetitionWon = 2;

NewLevelVariable("lastCompetitionLost","int");
lastCompetitionLost = 4;

///////////////////////////////////////////////////////////////////////////////

//Watchers love

NewLevelVariable("watchersLoveString","string");
watchersLoveString="WatchersLove";

NewLevelVariable("watcherMet","int");
watcherMet = 1;

NewLevelVariable("watcherAskedForHelpMcDisagreed","int");
watcherAskedForHelpMcDisagreed = 2;

NewLevelVariable("watcherAskedForHelpMcAgreed","int");
watcherAskedForHelpMcAgreed = 3;

NewLevelVariable("spokenWithSwifflinHadSuccess","int");
spokenWithSwifflinHadSuccess = 4;

NewLevelVariable("watcherGrantedHelp","int");
watcherGrantedHelp = 5;

NewLevelVariable("watcherIsUpset","int");
watcherIsUpset = 6;


///////////////////////////////////////////////////////////////////////////////
//////////////////////////////level constants /////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


// global constants
NewLevelVariable("messageTime","float");//Standart message duration in seconds
messageTime = 5;

///////////////////////////////////////////////////////////////////////////////

// concerning the magic trees
NewLevelVariable("maxParty","int");
maxParty = 6; //killer branches amount per tree

NewLevelVariable("redParty","int");
redParty = RedParty; //Party ID of red tree and branches

NewLevelVariable("greenParty","int");
greenParty = GreenParty; //Party ID of green tree and branches

NewLevelVariable("redBranch","string"); //ObjectID red killer branch
redBranch = "RedKillerBranch";

NewLevelVariable("redPlayerBranch","string"); //ObjectID red killer branch when mc enters tree event
redPlayerBranch = "RedPlayerBranch";

NewLevelVariable("greenBranch","string");//ObjectID green killer branch
greenBranch = "GreenKillerBranch";

NewLevelVariable("greenPlayerBranch","string");//ObjectID green killer branch when mc enters tree event
greenPlayerBranch = "GreenPlayerBranch";

NewLevelVariable("redTreeEvent","string"); //WorldID of sourrounding event of the red tree
redTreeEvent = "MagicRedTreeEnteredByKillerBranches";

NewLevelVariable("greenTreeEvent","string");//WorldID of sourrounding event of the green tree
greenTreeEvent = "MagicGreenTreeEnteredByKillerBranches";

NewLevelVariable("numberOfDefenders","int");//Number of branches released when tree is disturbed by one approaching enemy
numberOfDefenders = 2;

NewLevelVariable("redTree","string"); //WorldID red tree
redTree = "RedTree";

NewLevelVariable("greenTree","string");//WorldID green tree
greenTree = "GreenTree";

NewLevelVariable("mcEntersTreeEventDamage","int"); //Damage MC recieves when enters tree event area

NewLevelVariable("greenTime","float");
greenTime = 100; //Lasting of green tree satisfaction  
  
NewLevelVariable("redTime","float");
redTime = 100; //Same for red tree

NewLevelVariable("radiusMin","int");//Radius of min displacement relative to the center of the trees when branches fall off
radiusMin = 200;
NewLevelVariable("radiusMax","int"); //Radius of max displacement both radius define a ring
radiusMax = 300;

NewLevelVariable("branchAmount","int"); //max of amount of new branches per tree per time period see level cfg file
branchAmount = 2;

NewLevelVariable("branchGroupFallDown","float"); //in this period of time (sec) in which the branchAmount of branches falls of the tree
branchGroupFallDown = 5;

NewLevelVariable("branchFallDownDelay","float"); //since killerBranches.c is called periodically to add some noise this is the max of delay time where a group of branches should start to fall down after calling the script. It should not be greater than the callIntervall in the level cfg file
branchFallDownDelay=10;

NewLevelVariable("branchDefendDelay","float"); //is the delay new defenders fall of the tree if a branch enters the event surrounding the tree which was already there. (otherwise there will soon be maxParty times such branches)
branchDefendDelay= 2; //2 seconds seem reasonable


NewLevelVariable("lastMovePoint","int"); //the last move point on the map
//modify this if longer or shorter ways for the killerbranches should be used
lastMovePoint = 4;

NewLevelVariable("priority","int"); //priority of moving to the next point
priority = 0;

NewLevelVariable("dungScroll","string"); // WorldID of Objects needed to fertilize the trees
dungScroll=DungScroll;

///////////////////////////////////////////////////////////////////////////////
 
// concerning shooting competition
NewLevelVariable("swifflin","string"); //WorldID of Swifflin
  swifflin ="Swifflin";

NewLevelVariable("swifflinStrategy","string"); //strategy default of Swifflin
swifflinStrategy ="WeaponAndFireballFlee";  

NewLevelVariable("shootingStrategy","string"); //shooting at targets strategy
shootingStrategy ="SwifflinShootingAtTarget";
  
  NewLevelVariable("numberOfTargets","int"); //number of targets to shoot at
  numberOfTargets = 5;  //five is max, target0 to target4
  NewLevelVariable("shootingAt","string",numberOfTargets); //array of WorldIDs of targets
for (int i=0;i< numberOfTargets;i++)
  shootingAt[i] = "Moving Target " + string(i); //WorldIDs of targets
  
  NewLevelVariable("competitionTime","float"); //time shooting competition lasts for
  competitionTime = 60;
  
  NewLevelVariable("targetSpeed","float"); //speed of targets 20 is very speedy
  targetSpeed = 0.5;
  
  NewLevelVariable("numberOfCoinsForCompetition","int"); //number of coins mc must spend to join shooting competition with swifflin
  numberOfCoinsForCompetition = 5; // we try it with 5

///////////////////////////////////////////////////////////////////////////////

// concerning Watcher

NewLevelVariable("archeon","string"); //WorldID of Archeon the Watcher
archeon="Archeon";
NewLevelVariable("leaveWatcherTime","float"); //Time watcher gives mc to leave if he is upset
leaveWatcherTime=10;
NewLevelVariable("numberOfGoldCoinsTakenByWatcher","int"); //If watcher is upset he demands some gold unless mc wants him to attack
numberOfGoldCoinsTakenByWatcher=100;

NewLevelVariable("rhymeScroll","string"); //Item ID of the rhyme scroll
rhymeScroll="Rhyme of the watcher";
NewLevelVariable("answerScroll","string"); //Item ID of swifflins answer scroll
answerScroll="Swifflins answer";

NewLevelVariable("parfumBlue","string"); //Parfum from watcher that changes party to green party
parfumBlue="Parfume marolio Magnat";

NewLevelVariable("parfumRed","string"); //Parfum from watcher that changes party to red party
parfumRed="Parfume radium Excaliba";


///////////////////////////////////////////////////////////////////////////////
//////////////////////////////Level Variables /////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


//NewLevelVariable("branchArray","int",2000); //objIDs of killerBranches.c indicate the moving point position of the branch. Hope that there are not more than 2000 ojects !!! perhaps only temporary

//NewLevelVariable("branchArrayDirection","int",2000); //like before but now the values of the array are 0 if the branches move forward to attack and 1 if they move backwards to heal;

//NewLevelVariable("branchFirstEntered","int",2000); //like before but now the values of the array are 0 if the branches move forward to attack and 1 if they move backwards to heal;

NewLevelVariable("redST","float"); // Counter of elapsed red tree satisfaction
redST = 0;

NewLevelVariable("greenST","float");  // Counter of elapsed green tree satisfaction
greenST = 0;

NewLevelVariable("shootingResult","int",2); // Counter of the shooting result where shootingResult[0] is the result of MC
shootingResult[0] = 0;
shootingResult[1] = 0;

NewLevelVariable("shotTargets","int",numberOfTargets); //if shootingAt[i] = 1 target is shot

NewLevelVariable("competitionRunning","int"); //indicates if competition is running


///////////////////////////////////////////////////////////////////////////////
//////////////////////////////Level Init //// /////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#include "scripts\\garden\\messages\\LANG\\messages.c"
#include "scripts\\global\\dialogues\\LANG\\malvaren.c"

#include "scripts\\garden\\quests\\init.c"

string dungScroll="Dung Scroll";

// Malvaren shouldn'te be visible
FadeOut(GetObject("Malvaren"), 0);

//RunScript("scripts\\garden\\npc\\killerBranches.c"); //On init a group of branches already exists. Perhaps some branches are add manually

// fish random start time
int iCount=GetAllObjectsWithCfgID("Fish", 0);
for (iCount--; iCount>=0; iCount--)
{
	SetPathTime(objList[iCount], 5.5*rand());
	SetPathMoveSpd(objList[iCount], 0.1+rand()*0.3);
}

