// On init the Watcher script is loaded
// other initialization may be done
 
// structure of init.c file is the following
// at first story constants are declared
// then level constants seperated in theme blocks meaning variables are grouped by semantic meaning
// then level variables are initialized and declared
// then Work is done which has to be done to initialize level


// ============================================================================
// ||                  story variable constants                              ||
// ============================================================================

//Ghost ritual
NewLevelVariable("ghostRitualString","string");
ghostRitualString="Ghost Ritual";
NewLevelVariable("spokenWithSiberius","int");
spokenWithSiberius=1;
NewLevelVariable("corpseFound","int");
corpseFound=2;
NewLevelVariable("bookFound","int");
bookFound=4;
NewLevelVariable("readyForRitual","int");
readyForRitual=8;
NewLevelVariable("ritualSuccess","int");
ritualSuccess=9;
NewLevelVariable("spokenWithBaradun","int");
spokenWithBaradun=10;
NewLevelVariable("finished","int");
finished=12;

// ============================================================================
//necessary for follow_mc script
SetWorldID(mc_ID,McWorldID);
// ============================================================================


// ============================================================================
// ||                         level constants                                ||
// ============================================================================

//Planetarium

NewLevelVariable("planetariumLevel","string"); //name of the level
planetariumLevel="levels\\academy_planetarium\\academy_planetarium.cfg";


//Meeting room door quest
NewLevelVariable("scrollID","string"); //WorldID of the message scroll containing the password of the chamber
scrollID="Password Scroll";
NewLevelVariable("doorID","string"); //WorldID of the door
doorID="Meeting Room Door";
NewLevelVariable("failedUseDamage","float");
failedUseDamage=5;
NewLevelVariable("damageEffect","string");
damageEffect="blockSparks";
NewLevelVariable("password","string",8);
password[0]="Whiskey";
password[1]="Rum";
password[2]="Wodka";
password[3]="Wine";
password[4]="Beer";
password[5]="Grog";
password[6]="Hot Chocolate";
NewLevelVariable("dialogAbsolved","int"); //right codeword visible in dialog
dialogAbsolved=0;
NewLevelVariable("rightWord","int");
rightWord=int(rand()*6.99); //pos of the right codeword


//Ghost ritual
NewLevelVariable("baradunID","string"); //worldID and objectID of baradun
baradunID="Baradun";
NewLevelVariable("siberiusID","string");//worldID and objectID of siberius
siberiusID="Siberius";
NewLevelVariable("corpseID","string");//worldID and objectID of baradun's corpse
corpseID="Baradun Corpse";
NewLevelVariable("corpseItemID","string");//itemID of baradun's corpse
corpseItemID="Corpse of Baradun";

NewLevelVariable("ghostBookID","string");//worldID and objectID of ghost book
ghostBookID="Ghost Book";


NewLevelVariable("numberOfConjureEffects","int"); //how much effects are displayed during conjuring
numberOfConjureEffects = 2;
NewLevelVariable("conjureEffect","string",numberOfConjureEffects); //effect array
conjureEffect[0] = "FloorEffect1"; //first effect
conjureEffect[1] = "whirl 01"; //second effect

NewLevelVariable("effectDelay","float",numberOfConjureEffects); //array of pauses between effects, first pause is added after the first effect
effectDelay[0] = 2;
effectDelay[1] = 0.5;

NewLevelVariable("conjuringDistance","float"); //max distance to the corpse where conjuring remains possible
conjuringDistance=100;

NewLevelVariable("conjureTime","int"); //number of seconds in with the corpse must be clicked to conjure the ghost
conjureTime = 5;

#include "scripts\\hallsOfMasters\\3Statues\\init.c"


// ============================================================================

// ============================================================================
 
// ============================================================================

HallsOfMasters = GetLevelName(); //initiating the level name for the book of the ghosts

// ============================================================================
// ||                         level variables                                ||
// ============================================================================

//Meeting room door quest
NewLevelVariable("doorTouched","int");
doorTouched=0;
NewLevelVariable("passTemp","int",7);

//Ghost ritual
NewLevelVariable("baradunConjureable","int");

// ============================================================================
// ||                             level init                                 ||
// ============================================================================

#include "scripts\\hallsOfMasters\\scriptPaths.c" //including paths to the scripts which can be adjusted, all paths to files are stored there if they are run by a script

#include "scripts\\hallsOfMasters\\messages\\LANG\\messages.c";

#include "scripts\\hallsOfMasters\\dialogues\\LANG\\theodosius.c"
#include "scripts\\hallsOfMasters\\dialogues\\LANG\\meganteolis.c"








