
// #include "scripts\\halls_of_masters\\planetarium\\quests\\telescope\\laser.c"

int GetLaser(string sID, int idObj, int iGeneration)
{
	int id;
	if (TelescopeLaserGeneration<=iGeneration)
	{
		id=NPCSpawn("hm_pl_planetarium_laser_01", idObj);
		SetWorldID(id, sID);
		SetLaserCol(id);
		TelescopeLaserGeneration++;
	}
	else
	{
		id=GetObject(sID);
		NPCObjID(id, idObj);
	}

	if (GetCfgID(idObj)=="hm_pl_aimwindow_01")
	{
		SetHeight(id, GetHeight(idObj)+79);
	}
	else
	{
		SetHeight(id, GetHeight(idObj));
	}

	SetObjectFloat(id, GetObjectFloat(idObj));

	return id;
}

int GetLaser(string sID, int iGeneration, float x, float y, float fAngle, float fHeight)
{
	int id;
	if (TelescopeLaserGeneration<=iGeneration)
	{
		id=AddObject("hm_pl_planetarium_laser_01", x,y,DEG(fAngle), -1, fHeight);
		SetWorldID(id, sID);
		SetLaserCol(id);
		TelescopeLaserGeneration++;
	}
	else
	{
		id=GetObject(sID);
		SetPos(id, x,y);
		SetAngle(id, fAngle);
		SetHeight(id, fHeight);
	}
	return id;
}

void CalcLaser(int idLaser, int iGeneration)
{
	if (iGeneration>=256) return;

	TelescopeLaserLastCall=GetGameTime()-TelescopeLaserLastCall;

	int id;
	int iFound=0;

	float fAngle=GetAngle(idLaser);
	id=GetParent(idLaser);
	if (id>0)
	{
		fAngle+=GetAngle(id);
		if (TelescopeCalcLaserGeneration==iGeneration)
		{
			if ((GetConstantRotation(id)==0.0)&&(iFound==0))
			{
				TelescopeCalcLaserGeneration=-1;
			}
			else
			{
				iFound=1;
				TelescopeCalcLaserGeneration=iGeneration;
			}
		}
		else if ((TelescopeCalcLaserGeneration>iGeneration)||
				 (TelescopeCalcLaserGeneration==-1))
		{
			if (GetConstantRotation(id)!=0.0)
			{
				iFound=1;
				TelescopeCalcLaserGeneration=iGeneration;
			}
		}
	}

	float x1=GetPosX(idLaser);
	float y1=GetPosY(idLaser);
	float x2=cos(fAngle)*32*100;
	float y2=sin(fAngle)*32*100;
	int iType=GetObjectFloat(idLaser, 1);
	float f=0;
	if (iType==0)
	{
		f=GetIntersection(x1,y1, x1+x2,y1+y2, 1|2|8|16);
	}
	else
	{
		f=GetIntersection(x1,y1, x1+x2,y1+y2, 1);
	}
	x2=x2*f;
	y2=y2*f;

	if ((TelescopeLaserBreakerType==0)&&(TelescopeLaserBreakerID>0)&&(IsValidObject(TelescopeLaserBreakerID)==0))
	{
		if ((TelescopeCalcLaserGeneration==iGeneration)&&(iFound==0))
		{
			TelescopeCalcLaserGeneration=-1;
		}
		TelescopeLaserBreakerType=-1;
	}
	if ((TelescopeLaserBreakerType==0)&&
		(TelescopeLaserBreakerID>0)&&(IsCreature(TelescopeLaserBreakerID)!=0))
	{
		if ((TelescopeCalcLaserGeneration==iGeneration)&&(iFound==0))
		{
			TelescopeCalcLaserGeneration=-1;
		}
		TelescopeLaserBreakerType=-1;
	}

	string sIDLaser=GetWorldID(idLaser);
	int i;
	if (iType==0)
	{
		if (int(GetObjectFloat(idLaser, 4))!=0)
		{
			i=GetAllWallsWithWorldID(sIDLaser);
			while (i-->0)
			{
				RemoveWall(objList[i]);
			}
			SetObjectFloat(idLaser, 0, 4);
		}
		if ( ((iTmp[1]==0)&&(IsCreature(iTmp[0])==0)) ||
			 (iTmp[1]==1) )
		{
			if (TelescopeCalcLaserGeneration==-1)
			{
				int idWall=AddWall("hm_pl_LaserCollision_01", x1,y1, x1+x2, y1+y2, 0,1, "WorldID=\""+string(GetWorldID(idLaser))+"\"");
				SetObjectFloat(idLaser, 1, 4);
			}
		}
		else if (iTmp[1]==0)
		{
			if ((TelescopeCalcLaserGeneration>iGeneration)||
				(TelescopeCalcLaserGeneration==-1))
			{
				iFound=1;
				TelescopeCalcLaserGeneration=iGeneration;
			}
		}
	}
	else
	{
		if (GetAllObjectsWithinRadius(x1+x2, y1+y2, 1, "hm_pl_aimwindow_01")!=0)
		{
			iTmp[0]=objList[0];
			iTmp[1]=0;
		}
	}
	
	float fLength=sqrt(x2*x2+y2*y2);

	int iEnd=1;
	string sID;
	sIDLaser+=" ";

	if (iTmp[1]==0)
	{
		sID=GetCfgID(iTmp[0]);
		if (sID=="hm_pl_aimwindow_01")
		{
			fLength+=20;

			sID=GetObjectString(iTmp[0]);
			if (sID!="")
			{
				id=GetLaser(sIDLaser, GetObject(sID), iGeneration);
				iEnd=0;
			}
		}
	}
	else
	{
		id=GetWallObject(iTmp[0]);
		if (id>0)
		{
			if (TelescopeCalcLaserGeneration==iGeneration)
			{
				if ((GetConstantRotation(id)==0.0)&&(iFound==0))
				{
					TelescopeCalcLaserGeneration=-1;
				}
				else
				{
					iFound=1;
					TelescopeCalcLaserGeneration=iGeneration;
				}
			}
			else if ((TelescopeCalcLaserGeneration>iGeneration)||
					 (TelescopeCalcLaserGeneration==-1))
			{
				if (GetConstantRotation(id)!=0.0)
				{
					iFound=1;
					TelescopeCalcLaserGeneration=iGeneration;
				}
			}
		}

		sID=GetWallCfgID(iTmp[0]);
		if (sID=="hm_pl_LaserMirror_01")
		{
			GetWallPos(iTmp[0]);

			float fAngle2=(Vect2Angle(fTmp[1]-fTmp[3], fTmp[2]-fTmp[0])+pi2)%pi2;
			fAngle=(fAngle-fAngle2+pi2*2.5)%pi2-pi;

			if ((fAngle>-pi)&&
				(fAngle< pi))
			{
				fAngle2=fAngle2-fAngle+pi;

				f=(fLength-1)/fLength;
				id=GetLaser(sIDLaser, iGeneration,
							x1+x2*f,
							y1+y2*f,
							fAngle2, GetHeight(idLaser));
				SetObjectFloat(id, GetObjectFloat(idLaser));
				iEnd=0;
			}
		}
	}
	SetScale3D(idLaser, fLength, 1,1);

	if (iEnd==0)
	{
		CalcLaser(id, iGeneration+1);
	}
	else
	{
		if ((TelescopeLaserBreakerID!=iTmp[0])||
			(TelescopeLaserBreakerType!=iTmp[1])||
			(TelescopeLaserTypeOld!=LaserType))
		{
			if (TelescopeLaserBreakerType==0)
			{
			}
			else
			{
				sID=GetWallCfgID(TelescopeLaserBreakerID);
				if (sID=="hm_pl_LaserEffect_01")
				{
					i=SplitString(GetWallString(TelescopeLaserBreakerID));
					if (sID!="")
					{
						id=GetObject(sTmp[0]);
						FadeOut(id, 1);
						if ((i>=2)&&(sTmp[1]!=""))
						{
							RequestRunScript("SetObjectSound("+string(id)+", 5, \"\");", 1);
						}
					}
				}
			}
			if (iTmp[1]==0)
			{
				sID=GetWorldID(iTmp[0]);
				if (sID=="Indragul")
				{
					indragulRemoveArmour();
				}
			}
			else
			{
				sID=GetWallCfgID(iTmp[0]);
				if ((sID=="hm_pl_LaserEffect_01")&&(LaserType==1))
				{
					i=SplitString(GetWallString(iTmp[0]));
					if (sTmp[0]!="")
					{
						id=GetObject(sTmp[0]);
						FadeIn(id, 1);
						if ((i>=2)&&(sTmp[1]!=""))
						{
							SetObjectSound(id, 5, sTmp[1]);
						}
					}
				}
			}
		}
		TelescopeLaserBreakerID=iTmp[0];
		TelescopeLaserBreakerType=iTmp[1];
		TelescopeLaserTypeOld=LaserType;

		if (LaserType==2)
		{
			if (iTmp[0]==mc_ID)
			{
				SetMana(mc_ID,GetMana(mc_ID)-TelescopeLaserLastCall*40);
				if (GetMana(mc_ID)<0)
				{
					SetMana(mc_ID, 0);
				}
			}
		}

		if (TelescopeLaserGeneration>iGeneration)
		{
			i=GetAllObjectsWithWorldID(sIDLaser, 0);
			while (i-->0)
			{
				RemoveObject(objList[i]);
			}
			i=GetAllWallsWithWorldID(sIDLaser, 0);
			while (i-->0)
			{
				RemoveWall(objList[i]);
			}
			TelescopeLaserGeneration=iGeneration;
		}

		if ((TelescopeHitEffectType!=LaserType)&&(TelescopeHitEffectID!=-1))
		{
			RemoveObject(TelescopeHitEffectID);
			TelescopeHitEffectID=-1;
			TelescopeHitEffectType=-1;
		}
		if (TelescopeHitEffectID==-1)
		{
			switch (LaserType)
			{
			case 1:
				TelescopeHitEffectID=AddEffectObject("E_Laser_Hit",0,0,0);
				TelescopeHitEffectType=1;
				break;
			case 2:
				TelescopeHitEffectID=AddEffectObject("E_Laser_Hit",0,0,0);
				TelescopeHitEffectType=2;
				break;
			}
		}
		if (TelescopeHitEffectID!=-1)
		{
			SetPos(TelescopeHitEffectID, x1+x2,y1+y2);
			SetHeight(TelescopeHitEffectID, GetHeight(idLaser));
		}
	}

	TelescopeLaserLastCall=GetGameTime();

	if (LaserType==0)
	{
		TelescopeCalcLaserGeneration=-1;
		return;
	}
}

void CalcLaserEx()
{
	if (TelescopeCalcLaserGeneration<0)
	{
		TelescopeLaserLastCall=GetGameTime();
		RequestRunScript("scripts/halls_of_masters/planetarium/quests/telescope/calc_laser.c");
	}
	TelescopeCalcLaserGeneration=0;
}

void SetLaserCol(int id)
{
	switch (LaserType)
	{
	case 0:
		FadeOut(id, 0);
		FadeOut(id, 0);
		break;
	case 1:
		SetColor(id,    0,0,1,    0,0,1);
		SetColorAdd(id, 0,0,1); 

		FadeIn(id, 0);
		FadeIn(id, 0);
		break;
	case 2:
		SetColor(id,    1,0,0,    1,0,0);
		SetColorAdd(id, 1,0,0);

		FadeIn(id, 0);
		FadeIn(id, 0);
		break;
	}
}

void SetLaser(int iType)
{
	if (iType==LaserType) return;
	LaserType=iType;

	if (iType==0)
	{
		CalcLaserEx();
	}

	int i=GetAllObjectsWithWorldID("Laser", 0);
	while (i-->0)
	{
		SetLaserCol(objList[i]);
	}

	if (iType!=0)
	{
		CalcLaserEx();
	}
}
