
// scripts\\halls_of_masters\\planetarium\\quests\\telescope\\rotate_platform_func.c

#include "laser.c"


void InitPlatformObjects()
{
	PlatformObjectsCount=0;
	int id,iTmp=GetObject("TelescopePlatform"),tp;
	iTmp=GetAllObjectsWithinRadius(GetPosX(iTmp),GetPosY(iTmp), GetSize(iTmp));
	while (iTmp-->0)
	{
		id=objList[iTmp];
		if ((GetWorldID(id)!="Deflector")&&(GetParent(id)<0))
		{
			tp=GetObjectType(id);
			if( (tp==8||tp==6||id==mc_ID) && GetCfgID(id)!="" ) {
				PlatformObjects[PlatformObjectsCount++]=id;
				//LogToFile(GetCfgID(id),": ",id,"(",tp,") x:",GetPosX(id)," y:",GetPosY(id));
			}
		}
	}
}

void CheckLaserType()
{
	float x=(DEG(TelescopeAngle)-100.970)/6.297*2.0;
	float y=(DEG(TelescopeAngle2)-12.758)/8.572*2.0;

	if(x*x+y*y<=1.0)
	{
		SetLaser(1);
		return;
	}

	x=(DEG(TelescopeAngle)-65.126)/6.972*2.0;
	y=(DEG(TelescopeAngle2)-29.215)/6.756*2.0;
	if(x*x+y*y<=1.0)
	{
		SetLaser(2);
		return;
	}

	SetLaser(0);
}

void RotatePlatform(float fAngle)
{
	TelescopeAngle = fAngle;

	int pf=GetObject("TelescopePlatform");
	fAngle=(fAngle-GetAngle(pf)+RAD(360))%RAD(360);

	float s=GetSize(pf);

	int i=PlatformObjectsCount;
	while (i-->0)
	{
		if(IsValidObject(PlatformObjects[i]))
			RotateObjOnPlatform(PlatformObjects[i],pf,fAngle,s);
	}

	CheckLaserType();
}

void RotateTelescope(float fAngle)
{
	TelescopeAngle2 = fAngle;

	fAngle*=6.0/pi;
	SetObjectAni(GetObject("TelescopeTop"), fAngle,fAngle,fAngle);
	SetObjectAni(GetObject("TelescopeBottom"), fAngle,fAngle,fAngle);

	CheckLaserType();
}
